#  Copyright (C) 2014, 2015  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'twb'
require "test/unit"

system "cls"

class TestDocDashImageVert < Test::Unit::TestCase
 
  def test_create
    vDash = Twb::DocDashboardImageVert.new
    assert(!vDash.nil?, "Doc Dashboard creation should not be null")
    assert_equal('columnar Image', vDash.type)
    assert(!vDash.dashnode.nil?, "Doc Dashboard dashboard node should not be null")
    assert(!vDash.winnode.nil?, "Doc Dashboard window node should not be null")
    assert(!vDash.dashnode.at_xpath('.//zone[@type="bitmap"]').nil?, " <dashboard Web zone must not be null")
    assert(!vDash.winnode.at_xpath('.//zone[@type="bitmap"]').nil?,  " <window Web zone must not be null")
  end
  
  def test_assignname
    vDash = Twb::DocDashboardImageVert.new
    vDash.title=('test title name')
    assert_equal('test title name', vDash.title)
    assert(!vDash.dashnode.attribute('name').nil?)
    puts "  -- dash node  #{vDash.dashnode.class} :: "
    puts "  -- wind node  #{vDash.winnode.class} :: "
    assert(!vDash.winnode.attribute('name').nil?)
    assert_equal('test title name', vDash.dashnode.attribute('name').value)
    assert_equal('test title name', vDash.winnode.attribute('name').value)
  end
 
  def test_assigImage
    vDash = Twb::DocDashboardImageVert.new
    vDash.image=('test Image')
    assert_equal('test Image', vDash.image)
  end
  
  def test_inject
    vDash = Twb::DocDashboardImageVert.new
    vDash.title=('Injected Documentation Dashboard')
    vDash.image=('C:\\tech\\Tableau\\TWBs\\Tableau Sample Workbooks\\World Indicators.twb.png')
    do_injection(vDash, 'No Content.twb')
    do_injection(vDash, 'No Dashboards.twb')
  end
  
  def do_injection(dash, twbName)
    twb   = Twb::Workbook.new(twbName)
    assert(!twb.nil?)
    twb.addDocDashboard dash
    twb.writeAppend('injectedImage')
  end
 
end