#  Copyright (C) 2014, 2015  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'C:\tech\Tableau\tools\Ruby\gems\twb\lib\twb.rb'
require "test/unit"

system "cls"

class TestDotFileRenderer < Test::Unit::TestCase
  
  @@testDotFile = 'TwoSheetDash.twb.dot'

  def test_createClass
    renderer = Twb::Util::DotFileRenderer.new
    assert(!renderer.nil?)
  end
  
  def test_render
    renderer = Twb::Util::DotFileRenderer.new
    renderedFiles = renderer.renderAll(@@testDotFile)
    assert_equal(renderedFiles.length, 3)
    assert(renderedFiles.include?('TwoSheetDash.twb.dot' + '.pdf'), 'Expected Rendered file name not found' )
    assert(renderedFiles.include?('TwoSheetDash.twb.dot' + '.png'), 'Expected Rendered file name not found' )
    assert(renderedFiles.include?('TwoSheetDash.twb.dot' + '.svg'), 'Expected Rendered file name not found' )
  end
  
  def test_SpecifyType
    renderer = Twb::Util::DotFileRenderer.new
    renderedFile = renderer.render(@@testDotFile,:pdf)
    assert(!renderedFile.nil?)
    renderedFile = renderer.render(@@testDotFile,:png)
    assert(!renderedFile.nil?)
    renderedFile = renderer.render(@@testDotFile,:svg)
    assert(!renderedFile.nil?)
    renderedFile = renderer.render(@@testDotFile,'xyz')  # should fail
    assert(renderedFile.nil?)
  end
 
end
