#  Copyright (C) 2014, 2015  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'C:\tech\Tableau\tools\Ruby\gems\twb\lib\twb.rb'
require "test/unit"

system "cls"

class TestTwbDashSheetDataDotBuilder < Test::Unit::TestCase

  def test_createFromClass
    #puts "\n\n\n      == TwoSheetDash.twb"
    twb  = Twb::Workbook.new('TwoSheetDash.twb')
    dotBuilder = Twb::Util::TwbDashSheetDataDotBuilder.new(twb)
    assert_equal(dotBuilder.workbook.name, 'TwoSheetDash.twb')
    assert(dotBuilder.instance_of?(Twb::Util::TwbDashSheetDataDotBuilder))
  end

  def test_createFromFileName
    #puts "\n\n\n      == TwoSheetDash.twb"
    db = Twb::Util::TwbDashSheetDataDotBuilder.new('TwoSheetDash.twb')
    assert_equal(db.workbook.name, 'TwoSheetDash.twb')
    assert(db.instance_of?(Twb::Util::TwbDashSheetDataDotBuilder))
    assert_equal(db.dotFileName, 'TwoSheetDash.twb.dot')
    assert_equal(db.dashCount,  1 )
    assert_equal(db.sheetCount, 2 )
    assert_equal(db.dataSourceCount, 2 )
    assert(!File.open('TwoSheetDash.twb.dot').nil?)  # DOT file exists
  end
  

end
